<?php
/*---------------------------------------------------------------*/
/*
    Titre : Pagination PDO                                                                                                
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=1161
    Auteur           : GrayJoe                                                                                            
    Date dition     : 13 Juin 2023                                                                                       
    Date mise  jour : 24 Nov 2023
                                                                                       
    Rapport de la maj:                                                                                                    
    - formatage de la description                                                                                         
*/
/*---------------------------------------------------------------*/
/*à personnaliser suivant votre serveur mysql*/
define('USER',"root");
define('PASSWD',"");
define('SERVER',"localhost");
define('BASE',"blogdc");

function connect_bd(){
    $dsn="mysql:dbname=".BASE.";host=".SERVER;
        try{
        $connexion=new PDO($dsn,USER,PASSWD);
        }
        catch(PDOException $e){
        printf("Échec de la connexion : %s\n", $e->getMessage());
        exit();
        }
    return $connexion;
}
/*ok on est connecte*/
$db=connect_bd();

/*non de la table à paginer*/
$table="posts"; 

/*nombre d'enregistrements de la table par page*/
$limit = 2;

/*requête sql pour le comptage de la totalité des enregistrements de la
 table*/
$query = "SELECT count(*) FROM $table";

/*on lance la requête*/
$s = $db->query($query);
$total_results = $s->fetchColumn();
/*on arrondit avec la fonction ceil la division, vers le haut poàur avoir un
 entier*/
$total_pages = ceil($total_results/$limit);
/*on utilise ici la variable GET['page'] qui passe par l'url*/
/*si rien n'est passé par défaut c'est 1, sinon on force par un cast à un
 entier la variable (sécu anti hack et injection de code par la variable)*/
if (!isset($_GET['page'])) {
    $page = 1;
} else{
    $page = (int)$_GET['page'];
}


/*on calcule le point d'entrée sur la table*/
$starting_limit = ($page-1)*$limit;
/*on ordonne par id qui doit être la clé primaire*/
$show  = "SELECT * FROM $table ORDER BY id DESC LIMIT :starting_limit,:limit";
/*on lance la requête*/
$r = $db->prepare($show);
$r->bindValue(':starting_limit', $starting_limit, PDO::PARAM_INT);
$r->bindValue(':limit', $limit, PDO::PARAM_INT);
$r->execute();
while($res = $r->fetch(PDO::FETCH_ASSOC)):
/*listage et affichage des enregistrements*/
?>
<h4><?php echo $res['id'];?></h4>
<!-- <p>ici une autre colonne de la table suivant la table</p>-->
<hr>
<?php
endwhile;

/*le menu de pagination*/
for ($page=1; $page <= $total_pages ; $page++):?>
<a href='<?php echo "?page=$page"; ?>' class="links"><?php  echo $page; ?>
 </a>
<?php endfor; ?>